#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private BetterXTrend[] cacheBetterXTrend;

		
		public BetterXTrend BetterXTrend(int lookback, bool trendChangeAlert, bool useTickVolume, string password)
		{
			return BetterXTrend(Input, lookback, trendChangeAlert, useTickVolume, password);
		}


		
		public BetterXTrend BetterXTrend(ISeries<double> input, int lookback, bool trendChangeAlert, bool useTickVolume, string password)
		{
			if (cacheBetterXTrend != null)
				for (int idx = 0; idx < cacheBetterXTrend.Length; idx++)
					if (cacheBetterXTrend[idx].Lookback == lookback && cacheBetterXTrend[idx].TrendChangeAlert == trendChangeAlert && cacheBetterXTrend[idx].UseTickVolume == useTickVolume && cacheBetterXTrend[idx].Password == password && cacheBetterXTrend[idx].EqualsInput(input))
						return cacheBetterXTrend[idx];
			return CacheIndicator<BetterXTrend>(new BetterXTrend(){ Lookback = lookback, TrendChangeAlert = trendChangeAlert, UseTickVolume = useTickVolume, Password = password }, input, ref cacheBetterXTrend);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.BetterXTrend BetterXTrend(int lookback, bool trendChangeAlert, bool useTickVolume, string password)
		{
			return indicator.BetterXTrend(Input, lookback, trendChangeAlert, useTickVolume, password);
		}


		
		public Indicators.BetterXTrend BetterXTrend(ISeries<double> input , int lookback, bool trendChangeAlert, bool useTickVolume, string password)
		{
			return indicator.BetterXTrend(input, lookback, trendChangeAlert, useTickVolume, password);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.BetterXTrend BetterXTrend(int lookback, bool trendChangeAlert, bool useTickVolume, string password)
		{
			return indicator.BetterXTrend(Input, lookback, trendChangeAlert, useTickVolume, password);
		}


		
		public Indicators.BetterXTrend BetterXTrend(ISeries<double> input , int lookback, bool trendChangeAlert, bool useTickVolume, string password)
		{
			return indicator.BetterXTrend(input, lookback, trendChangeAlert, useTickVolume, password);
		}

	}
}

#endregion
